/*
	標準偏差計算プログラム
	CalcStandardDiviation.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
double StandardDiviation(int N, double* val) {
	int i;
	double total = 0;			//合計値
	double average = 0.0;		//平均値
	double disperation = 0.0;	//分散値
	double diviation = 0.0;		//標準偏差
	
	//合計の計算
	for (i = 0; i < N; i++) {
		total += val[i];
	}
	
	//平均の計算
	average = total / N;
		
	//分散の計算
	for (i = 0; i < N; i++) {
		disperation += pow((val[i] - average), 2);
	}
	disperation /= N;

	//標準偏差の計算
	diviation = sqrt(disperation);

	return diviation;
}
int main(void)
{
	FILE* fp;
	char filename[] = "data.txt";	//ファイル名
	double* kokugo;					//国語の点数データ
	double* eigo;					//英語の点数データ
	double* sugaku;					//数学の点数データ
	int N = 0;						//データ数
	int count = 0;					//カウンタ

	//ファイル読み込み
	fp = fopen(filename, "r");
	if (fp == NULL) {
		printf("ファイルが開けません\n");
		exit(1);
	}

	//データ数を入力する
	scanf("%d", N);

	//人数分の国語、英語、数学のデータ領域を作成する
	kokugo = (double*)malloc(N * sizeof(double));
	eigo = (double*)malloc(N * sizeof(double));
	sugaku = (double*)malloc(N * sizeof(double));

	//人数分のデータ列をファイルから取得する
	while (fscanf(fp, "%lf %lf %lf"
		, &kokugo[count], &eigo[count], &sugaku[count]) != EOF) {
		count++;
	}

	//標準偏差を計算し、結果を表示する
	printf("国語の標準偏差 = %.2lf\n", StandardDiviation(N, kokugo));
	printf("英語の標準偏差 = %.2lf\n", StandardDiviation(N, eigo));
	printf("数学の標準偏差 = %.2lf\n", StandardDiviation(N, sugaku));

	//ファイルをクローズする
	fclose(fp);

	//メモリを解放する
	free(kokugo);
	free(eigo);

	return 0;
}
