/*
	スタックプログラム
	Stack.c
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define MAX_SIZE 10

//スタックの構造体データ
typedef struct {
	int data[MAX_SIZE];
	int sp;
}STACK_DATA;

//初期化関数
void init(STACK_DATA* stack) {
	int i;

	for (i = 0; i < MAX_SIZE; i++) {
		stack->data[i] = 0;
	}
	stack->sp = 0;
}
//プッシュ関数
void push(STACK_DATA* stack, int value) {
	//スタックが満杯になる場合は、メッセージを表示し、プッシュしない
	if (stack->sp < MAX_SIZE) {
		stack->data[stack->sp] = value;
		stack->sp++;
	} else {
		printf("プッシュできません\n");
	}
}
//ポップ関数
void pop(STACK_DATA* stack) {
	if (stack->sp > 0) {
		stack->sp--;
		printf("%dをポップしました\n", stack->data[stack->sp]);
		stack->data[stack->sp] = 0;
	} else {
		//ポップするものがない場合はプログラムを強制終了する
		printf("ポップできません\n");
	}

}
int main(void)
{
	//スタック構造体の宣言
	STACK_DATA stack;
	int val;
	int len;
	char temp_val[256];
	char command[256];

	//データの初期化
	init(&stack);

	//pushを入力した場合は、プッシュを実行
	//popを入力した場合は、ポップを実行
	//finを入力した場合は、プログラムを終了する
	while (1) {
		printf("push:プッシュ操作モード pop: ポップ操作モード fin: プログラムを終了\n");
		memset(command, '\0', sizeof(command));
		fgets(command, sizeof(command), stdin);
		len = strlen(command) - 1;

		if (command[len] == '\n'){
			command[len] = '\0';
		} else {
			while (getchar() != '\n') {}
		}

		if (strcmp(command, "push") == 0) {
			//コンソールから数字一文字を入力する
			printf("数字一文字を入力してください\n");
			memset(temp_val, '\0', sizeof(temp_val));
			fgets(temp_val, sizeof(temp_val), stdin);
			len = strlen(temp_val) - 1;

			if (temp_val[len] == '\n'){
				temp_val[len] = '\0';
			} else {
				while (getchar() != '\n') {}
			}
			if (len == 1) {
				if (temp_val[0] >= '0' && temp_val[0] <= '9'){
					val = 0;
					val = atoi(temp_val);
					//入力した1文字をプッシュする
					push(&stack, val);
					printf("%dをプッシュしました\n", val);
				} else {
					printf("プッシュできませんでした。\n");
				}
			} else {
				printf("プッシュできませんでした\n");
			}
		} else if (strcmp(command, "pop") == 0) {
			//スタックしたデータを一文字ポップする
			pop(&stack);
		} else if (strcmp(command, "fin") == 0) {
			printf("プログラム終了\n");
			break;
		} else {
			printf("コマンドに該当しませんでした\n");
		}
	}
	return 0;
}
