/*
	BinarySearch.c
	2分探索法のプログラム
*/
#include <stdio.h>
int binary_search(int array[], int target, int index_size);
int main(void)
{
	int array[] = {1, 3, 4, 5, 7, 12, 15, 16, 20};
	int index_size = 0;		//配列の要素数
	int target;				//検索する数値
	int result = 0;			//場所
	
	index_size = sizeof(array) / sizeof(array[0]);
	
	printf("検索する値を入力してください\n");
	scanf("%d",&target);
	result = binary_search(array, target, index_size);
	
	if (result == -1){
		printf("%dはありません.\n", target);
	} else {
		printf("場所は%d番目です.\n", result);
	}
	
	return 0;
}
/*
 * 関数名: binary_search
 * 機能  : 2分探索を実行する
 * 引数	 : int array[]:		入力する数値
		   int target:		検索する数値
		   int index_size:	配列のサイズ
 * 戻り値: 実行結果
*/
int binary_search(int array[], int target, int index_size){
	// low: 下限, high: 上限, mid: 中央値
	int low = 0, high = index_size - 1, mid = 0;
	
	while (low <= high) {
		mid = low + ( (high - low) / 2);
		if (array[mid] == target) {
			return mid;
		} else if (array[mid] > target){
			high = mid - 1;
		} else {
			low = mid + 1;
		}
	}
	return -1;
}
