/*
	ストップウォッチ・シミュレーター
	StopWatch.c
*/
#include <stdio.h>
#include "StopWatch.h"

int main(void) {
	int in;	//指令入力用変数

	// 初期モードは電源OFFモード
	globalMode = MODE_POWER_OFF;

	// モードを表示
	output();

	while (1) {
		// 指令をコンソールから入力
		scanf("%d", &in);
		switch (globalMode) {
			// 電源OFFモードの場合
		case MODE_POWER_OFF:
			if (in == ACT_POWER_ONOFF)
				globalMode = MODE_IDLE;
			break;
			// 計測モードの場合
		case MODE_START:
			if (in == ACT_RESET) {
				globalMode = MODE_IDLE;
			}
			else if (in == ACT_START) {
				globalMode = MODE_PAUSE;
			}
			else if (in == ACT_POWER_ONOFF) {
				globalMode = MODE_POWER_OFF;
			}
			break;
			// アイドルモードの場合
		case MODE_IDLE:
			if (in == ACT_START) {
				globalMode = MODE_START;
			}
			else if (in == ACT_POWER_ONOFF) {
				globalMode = MODE_POWER_OFF;
			}
			break;
			// 一時停止モードの場合
		case MODE_PAUSE:
			if (in == ACT_RESET) {
				globalMode = MODE_IDLE;
			}
			else if (in == ACT_START) {
				globalMode = MODE_START;
			}
			else if (in == ACT_POWER_ONOFF) {
				globalMode = MODE_POWER_OFF;
			}
			break;
		default:
			break;
		}
		// モードを表示
		output();
	}

	return 0;
}
// コンソールにモードを表示する
void output() {
	if (globalMode == MODE_POWER_OFF) {
		printf("電源OFFモード: ");
	}
	else if (globalMode == MODE_IDLE) {
		printf("アイドルモード: ");
	}
	else if (globalMode == MODE_PAUSE) {
		printf("一時停止モード: ");
	}
	else if (globalMode == MODE_START) {
		printf("計測モード: ");
	}
}
