#include <stdio.h>
int week_of_the_day(int year, int month, int day);

int main(void)
{
	int result = 0;
	int year, month, day;
	scanf("%d %d %d", &year, &month, &day);
	result = week_of_the_day(year, month, day);
	if (result == 0) {
		printf("%d(日曜日)\n", result);
	} else if (result == 1) {
		printf("%d(月曜日)\n", result);
	} else if (result == 2) {
		printf("%d(火曜日)\n", result);
	} else if (result == 3) {
		printf("%d(水曜日)\n", result);
	} else if (result == 4) {
		printf("%d(木曜日)\n", result);
	} else if (result == 5) {
		printf("%d(金曜日)\n", result);
	} else if (result == 6) {
		printf("%d(土曜日)\n", result);
	} else {
		printf("%d(エラー)\n", result);
	}
	
	return 0;
}

//曜日を求める関数
int week_of_the_day(int year, int month, int day) {
	int res = 0;
	//月ごとの最終日の一覧
	int day_table[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30 ,31 };

	//エラー処理
	if (year <= 1581 || year >= 3001) {
		return -1;
	}
	else if (month <= 0 || month >= 13) {
		return -1;
	}

	//グレゴリオ暦開始日を考慮したエラー処理
	if (year == 1582 && month < 11 && day < 15) {
		return -1;
	}
	
	//4で割り切れるかつ100で割り切れない、または400で割り切れる
	//場合は潤年とする
	if ((year % 4 == 0) && ((year % 100 != 0) || (year % 400 == 0))) {
		if (month == 2){
			day_table[month - 1]++;
		}
	}

	//エラー処理
	if (day <= 0 || day > day_table[month - 1]) {
		return -1;
	}
	
	//月が1か2の場合は、去年の13月、14月として計算する
	if (month == 1 || month == 2) {
		//去年にする
		year = year - 1;

		//12を加算し、13月か14月に変更する
		month = month + 12;
	}

	//ツェラー公式から曜日を算出する
	res = (year + year / 4 - year / 100 + year / 400 + (13 * month + 8) / 5 + day) % 7;

	return res;
}
