//曜日を求める関数
int week_of_the_day(int year, int month, int day) {
	int temp_day = 0;
	int res = 0;
	//月ごとの最終日の一覧
	int day_table[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30 ,31 };

	temp_day = day_table[month - 1];
	if (year <= 1580 || year >= 3001) {
		return -1;
	}
	else if (month <= 0 && month >= 13) {
		return -1;
	}
	else if (day <= 0 || day > temp_day) {
		return -1;
	}

	//4で割り切れるかつ100で割り切れない、または400で割り切れる
	//場合は潤年とする
	if ((year % 4 == 0) && (year % 100 != 0) || (year % 400 == 0)) {
		day = day + 1;
	}

	//月が1か2の場合は、去年の13月、14月として計算する
	if (month == 1 || month == 2) {
		//去年にする
		year = year - 1;

		//12を加算し、13月か14月に変更する
		month = month + 12;
	}

	//ツェラー公式から曜日を算出する
	res = (year + year / 4 - year / 100 + year / 400 + (13 * month + 8) / 5 + day) % 7;

	return res;
}
