/*
	PorlandCalculator.c
	電卓プログラム
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define MAX_SIZE 40			//最大文字数38文字
//スタックの構造体
typedef struct {
	int data[MAX_SIZE];		//データ
	int sp;					//スタックポインタ
}STACK_DATA;
void init(STACK_DATA* stack);
void push(STACK_DATA* stack, int value);
int pop(STACK_DATA* stack);
void iserror(char* str);
int main(void) {
	char eq[MAX_SIZE];		//入力する式
	char buf[MAX_SIZE];		//一時変数
	char* ptr;				//文字列ポインタ
	int op1 = 0, op2 = 0;	//オペランド1,2 
	int i;					//ループ変数
	STACK_DATA stack;		//スタックの構造体変数

	//スタックを初期化
	init(&stack);

	//変数を初期化し、コンソールから式を入力
	memset(eq, '\0', sizeof(eq));
	fgets(eq, sizeof(eq), stdin);

	//式にエラーが無いかチェックする
	iserror(eq);

	//入力した式が改行になるまで繰り返す
	ptr = eq;
	while (*ptr != '\n') {
		//文字が「0～9」,「+」,「-」,「*」,「/」か判定する
		if (*ptr >= '0' && *ptr <= '9') {
			i = 0;
			memset(buf, '\0', sizeof(buf));
			//次の文字が改行、空白、+、-、*、/まで繰り返す
			while (*ptr != '\n' && *ptr != ' ' && *ptr != '+' && *ptr != '-' && *ptr != '*' && *ptr != '/') {
				buf[i++] = *ptr;
				ptr++;
			}
			//値をプッシュする
			push(&stack, atoi(buf));
			if (*ptr == '\n')
				break;
		} else if (*ptr == '+') {
			//値を加算し、結果をプッシュする
			op2 = pop(&stack);
			op1 = pop(&stack);
			push(&stack, op1 + op2);
		} else if (*ptr == '-') {
			//値を減算し、結果をプッシュする
			op2 = pop(&stack);
			op1 = pop(&stack);
			push(&stack, op1 - op2);
		} else if (*ptr == '*') {
			//値を乗算し、結果をプッシュする
			op2 = pop(&stack);
			op1 = pop(&stack);
			push(&stack, op1 * op2);
		} else if (*ptr == '/') {
			//値を除算し、結果をプッシュする
			op2 = pop(&stack);
			op1 = pop(&stack);
			push(&stack, op1 / op2);
		}
		ptr++;
	}

	//結果を出力する
	if (stack.sp == 1){
		printf("結果 = %d\n", pop(&stack));
	} else {
		printf("計算エラー\n");
	}
	return 0;
}
//エラーチェック用関数
void iserror(char* eq){
	int i, len = strlen(eq) - 1;

	if (eq[len] == '\n'){
		//文字列を改行が来るまで繰り返し、
		//不正な文字が入っていないか確認する
		for (i = 0; eq[i] != '\n'; i++) {
			if (!(eq[i] >= '0' && eq[i] <= '9')) {
				if (eq[i] != '+' && eq[i] != '-' &&
					eq[i] != '*' && eq[i] != '/' &&
					eq[i] != ' ' && eq[len] != '\n' ) {
					printf("計算エラー\n");
					exit(1);
				}
			}
		}
	} else {
		printf("計算エラー\n");
		exit(1);
	}
}
//スタックの初期化
void init(STACK_DATA* stack) {
	int i;

	//データ、スタックポインタを初期化する
	for (i = 0; i < MAX_SIZE; i++) {
		stack->data[i] = 0;
	}
	stack->sp = 0;
}
//プッシュ関数
void push(STACK_DATA* stack, int value) {
	//プッシュ可能な場合は、プッシュ操作をする
	if (stack->sp < MAX_SIZE) {
		stack->data[stack->sp] = value;
		stack->sp++;
	} else {
		printf("計算エラー\n");
		exit(1);
	}
}
//ポップ関数
int pop(STACK_DATA* stack) {
	int value = 0;

	//ポップ可能な場合は、ポップ操作をする
	if (stack->sp > 0) {
		stack->sp--;
		value = stack->data[stack->sp];
		stack->data[stack->sp] = 0;
		return value;
	} else {
		printf("計算エラー\n");
		exit(1);
	}
}
